#include <iostream>
#define _USE_MATH_DEFINES
#include <math.h>
#include <stdio.h>
#include <fstream>
#include <sstream>
#include <stdint.h>
#include <string>
#include <vector>

using namespace std;

int getNumberOfLines(string file) // function to obtain number of outlets from file with listed outlet radii. Name of file is inserted in command line when programm is executed.
{
	int number_of_lines=0;
	string line;
	ifstream myfile(file.c_str());

	if(myfile.is_open())
	{
		while(!myfile.eof())
		{
			{
				getline(myfile,line);
				if (line.empty()) // make sure, only non-blank lines are counted!
				{
//					cout << "Empty line." << endl;
				}
				else
				{
//					cout << line << endl;
					number_of_lines++;
				}
			}
		}
		myfile.close();
	}

	cout << "Number of lines in " << file << " is " << number_of_lines << endl;
	
	return number_of_lines;
}

double getCoordinateEntries(string file, int numberOfEntries, double arrayX[], double arrayY[], double arrayZ[], double arrayRadius[])

{
//	double result[3];
//	double sumX=0, sumY=0, sumZ=0;
	string line;
	ifstream infile(file.c_str());
	if(infile.fail())
	{
		cout << "Error: File " << file.c_str() << " could not be opened." << endl;
		return 1;
	}
//	double arrayX[numberOfEntries];
//	double arrayY[numberOfEntries];
//	double arrayZ[numberOfEntries];
	stringstream fileName;
	for(int i=0; i<numberOfEntries; i++)
	{
//		getline(infile, line);
		infile >> arrayX[i];
		infile >> arrayY[i];
		infile >> arrayZ[i];
		infile >> arrayRadius[i];

	
		cout << file.c_str() << " arrayX[" << i << "]: " << arrayX[i] << endl;
		cout << file.c_str() << " arrayY[" << i << "]: " << arrayY[i] << endl;
		cout << file.c_str() << " arrayZ[" << i << "]: " << arrayZ[i] << endl;
		cout << file.c_str() << " arrayRadius[" << i << "]: " << arrayRadius[i] << endl;

	}
	infile.close();

	return 0;
}


int main()
{
	int N_outlets = 0;
	double scalingFactor = 0.001;

	cout << "What is the number of outletPatches?" << endl;
	cin >> N_outlets;

	cout << "What is the scalingFactor of the model?" << endl;
	cin >> scalingFactor;

	stringstream tmpFileName;
	string fileName;

	int numberOfEntries[N_outlets];
	double distances[N_outlets];
	double volumes[N_outlets];
	
	for(int j=0; j<N_outlets; j++)
	{
		double tmpOutletCenterpoint[3];
		tmpFileName << "centerline" << j+1 << ".txt";
		fileName = tmpFileName.str();
		numberOfEntries[j+1] = getNumberOfLines(fileName);
		double xCoordinate[numberOfEntries[j+1]];
		double yCoordinate[numberOfEntries[j+1]];
		double zCoordinate[numberOfEntries[j+1]];
		double radiusCoordinate[numberOfEntries[j+1]];
		getCoordinateEntries(fileName, numberOfEntries[j+1], xCoordinate, yCoordinate, zCoordinate, radiusCoordinate);
		tmpFileName.str("");
		double squareRootSum=0;
		volumes[j]=0; 
		for(int i=1; i<numberOfEntries[j+1]; i++)
		{
			double partialCylinderLength=0;			
			squareRootSum += sqrt(pow(xCoordinate[i]-xCoordinate[i-1],2)+pow(yCoordinate[i]-yCoordinate[i-1],2)+pow(zCoordinate[i]-zCoordinate[i-1],2));
			partialCylinderLength = sqrt(pow(xCoordinate[i]-xCoordinate[i-1],2)+pow(yCoordinate[i]-yCoordinate[i-1],2)+pow(zCoordinate[i]-zCoordinate[i-1],2));
			cout << "xCoordinate is: " << xCoordinate[i] << endl;
			cout << "yCoordinate is: " << yCoordinate[i] << endl;
			cout << "zCoordinate is: " << zCoordinate[i] << endl;
			cout << "radiusCoordinate is: " << radiusCoordinate[i] << endl;
			cout << "partialCylinderLengths is: " << partialCylinderLength << endl;
			volumes[j]+=pow(scalingFactor,3)*partialCylinderLength*M_PI*pow(radiusCoordinate[i-1],2);
			cout << "volume at entry " << i << " is: " << volumes[j] << endl;
		}
		distances[j]=scalingFactor*squareRootSum;
		cout << "distance to outlet" << j+1 << " is: " << distances[j] << "." << endl;
		cout << "volume between inlet and outlet" << j+1 << " is: " << volumes[j] << "." << endl;
	}


	ofstream output("volumes.txt");
//	double distances[N_outlets];
//	double arc[N_outlets];
	for(int n=0; n<N_outlets; n++)
	{
		cout << "Distance Inlet to outlet" << n+1 << " is: " << 1000*distances[n] << " mm. " << endl;
		cout << "Volume between Inlet and outlet" << n+1 << " is: " << volumes[n] << " m³ or " << 1000000*volumes[n] << " ml respectively " <<endl;
		output.precision(10);
		output << volumes[n] << endl;
	
	}
	
	return 0;
}








