#include <iostream>
#define _USE_MATH_DEFINES
#include <math.h>
#include <stdio.h>
#include <fstream>
#include <sstream>
#include <stdint.h>
#include <string>

using namespace std;

double changingCapacitorVoltage(double timeIncrement, double previousVoltage, double current, double previousCurrent, double capacity, double density)
{
	double result=0;
	result = previousVoltage + 1/capacity * (current - previousCurrent)/2 *timeIncrement/density;
	return result;
}


int getNumberOfLines(string file) // function to obtain number of Lines from File with myocardial Pressure. Name of file is inserted in command line when programm is executed.
{
	int number_of_lines=0;
	string line;
	ifstream myfile(file.c_str());

	if(myfile.is_open())
	{
		while(!myfile.eof())
		{
			{
				getline(myfile,line);
				if (line.empty()) // make sure, only non-blank lines are counted!
				{
//					cout << "Empty line." << endl;
				}
				else
				{
//					cout << line << endl;
					number_of_lines++;
				}
			}
		}
		myfile.close();
	}

//	cout << "Number of lines in " << file << " is " << number_of_lines << endl;
	
	return number_of_lines;
}

double readFile(string fileName, double array[], int s)
{
	ifstream infile(fileName.c_str());
//	int s=0;
	string line;
	stringstream Str;

	if(infile.is_open())
	{
		while(!infile.eof())
		{
			{
				getline(infile,line);
				if (line.empty()) //make sure empty lines are not read into array.
				{
//					cout << "Empty line." << endl;
				}
				else
				{
					Str << line;
					Str >> array[s];
					Str.clear(); // Stringstream needs to be cleared in order to be written correctly in next step.
//					cout << "outletRadius" << s << ":" << outletRadiusArray[s] << endl;
					s++;
				}
			}
		}
		infile.close();
	}

	return 0;
}

int main()
{
	int N_outlets=0;

	cout << "Reading file: finalVesselResistances.txt" << endl;

//	cin >> fileOutletFractals;
	N_outlets = getNumberOfLines("finalVesselResistances.txt");
	cout << "Number of outlets is: " << N_outlets << endl;

	double vesselResistancesArray[N_outlets];
	double venousResistancesArray[N_outlets];
	double capacitanceArray[N_outlets];

	readFile("finalVesselResistances.txt",vesselResistancesArray,1);

	for(int i=1; i<=N_outlets; i++)
	{
		cout << "arterial Resistance @ outlet" << i << ": " << vesselResistancesArray[i] << " kg/(m^4*s)." << endl;
		
	}
	cout << "Reading file: venousResistances.txt" << endl;
	readFile("venousResistances.txt",venousResistancesArray,1);

	for(int i=1; i<=N_outlets; i++)
	{
		cout << "venous Resistance @ outlet" << i << ": " << venousResistancesArray[i] << " kg/(m^4*s)." << endl;
		
	}

	bool stressRestState;
	double capacitance=0;
	cout << "if rest state enter 0, if stress state enter 1: " ;
	cin >> stressRestState;

	for(int i=1; i<=N_outlets; i++)
	{
	if(stressRestState == 0)
	{	
		capacitanceArray[i] = 1.14/vesselResistancesArray[i];//0.814/vesselResistancesArray[i];
		cout << "capacitance @ outlet" << i << ": " << capacitanceArray[i] << " m^4*s^2/kg." << endl;
		cout << "COMPUTATION FOR REST STATE!!!" << endl;
	}
	if(stressRestState == 1)
	{
		capacitanceArray[i] = 1.3/vesselResistancesArray[i];//0.814/vesselResistancesArray[i];
		cout << "capacitance @ outlet" << i << ": " << capacitanceArray[i] << " m^4*s^2/kg." << endl;
		cout << "COMPUTATION FOR STRESS STATE!!!" << endl;
	}
	}

/*
	bool stressRestState;
	double R_arterial=345.6e8, R_capillary1=72e8, R_capillary2=72e8, R_venous=86.4e8;
	double capacitance=0;
	cout << "if rest state enter 0, if stress state enter 1: " ;
	cin >> stressRestState;
	if(stressRestState == 0)
	{
		cout << " REST STATE! " << endl;
		capacitance = 2.75e-11;
		cout << "total arterial resistance R_arterial: " << R_arterial << " kg/(m^4*s)." << endl
		     << "capillary Resistance 1: R_capillary1: " << R_capillary1 << " kg/(m^4*s)." << endl
		     << "capillary Resistance 2: R_capillary2: " << R_capillary2 << " kg/(m^4*s)." << endl
		     << "venous Resistance: R_venous: " << R_venous << " kg/(m^4*s)." << endl
		     << "compliance of intramyocardial vessels: capacitance: " << capacitance << " m^4*s^2/kg." << endl;
	}
	else if(stressRestState == 1)
	{
		cout << " STRESS STATE! " << endl;
		capacitance = 6.75e-11;
		R_arterial *= 0.25;//estimated total resistance of one artery in model and arterioles behind
//		R_capillary1 = 72e8;  //capillary resistance does not change under stress!
//		R_capillary2 = 72e8;
		R_venous *=0.02;
		cout << "total arterial resistance R_arterial: " << R_arterial << " kg/(m^4*s) (reduced by 86%)." << endl
		     << "capillary Resistance 1: R_capillary1: " << R_capillary1 << " kg/(m^4*s) (unchanged)." << endl
		     << "capillary Resistance 2: R_capillary2: " << R_capillary2 << " kg/(m^4*s) (unchanged)." << endl
		     << "venous Resistance: R_venous:" << R_venous << " kg/(m^4*s) (reduced by 98%)." << endl
		     << "compliance of intramyocardial vessels: capacitance: " << capacitance << " m^4*s^2/kg." << endl;
	}


	double R_star=0, R_normal=0;
	R_star = (R_arterial + R_capillary1)*(R_capillary2 + R_venous)/(R_arterial + R_capillary1 + R_capillary2 + R_venous);
	R_normal = R_capillary2 + R_venous;
	
	cout << "Effective resistance for dis/-charging across both branches of the circuit: " << R_star << " kg/(m^4*s)." << endl;	
	cout << "Effective resistance for dis/-charging across only venous branch of the circuit: " << R_normal << " kg/(m^4*s)." <<endl;		

	double capacitorTimeConstant_star = 0, capacitorTimeConstant_normal = 0;
	capacitorTimeConstant_star = capacitance * R_star;
	capacitorTimeConstant_normal = capacitance * R_normal;

	cout << "TimeConstant of capacitor for dis/-charging across both branches of the circuit: " << capacitorTimeConstant_star << " s" << endl;	
	cout << "TimeConstant of capacitor for dis/-charging across only venous branch of the circuit: " << capacitorTimeConstant_normal << " s" << endl;	
*/	

	int numberOfTimesteps;
	string filename;
	// choose input file with list of outlet radii (in m)
	cout << "What is the name of the input-File with ventricular pressure timesteps for one cycle (list WITHOUT times!!)?" << endl;
	cin >> filename;
	
	string filename1;
	// choose input file with list of outlet radii (in m)
	cout << "What is the name of the input-File with inlet pressure timesteps for one cycle (list WITHOUT times!!)?" << endl;
	cin >> filename1;
	
	numberOfTimesteps = getNumberOfLines(filename);
	cout << "Number of timesteps in ventricular pressure file is: " << numberOfTimesteps << endl;

	double cycleDuration = 1;
	cout << "Insert cardiac cycle duration (in s): " << endl;	
	cin >> cycleDuration;
	double timeStepSize=0;
	timeStepSize = cycleDuration/numberOfTimesteps;
	cout << "time step size is: " << timeStepSize << " s" << endl;	


	double myocardialPressureArray[numberOfTimesteps];
// readin of pressure timesteps from file into myocardialPressureArray
	ifstream infile(filename.c_str());
	int s=0;
	string line;
	stringstream Str;

	if(infile.is_open())
	{
		while(!infile.eof())
		{
			{
				getline(infile,line);
				if (line.empty()) //make sure empty lines are not read into array.
				{
//					cout << "Empty line." << endl;
				}
				else
				{
					Str << line;
					Str >> myocardialPressureArray[s];
					Str.clear(); // Stringstream needs to be cleared in order to be written correctly in next step.
//					cout << "outletRadius" << s << ":" << outletRadiusArray[s] << endl;
					s++;
				}
			}
		}
		infile.close();
	}
	
	double inletPressureArray[numberOfTimesteps];		
	
// readin of inlet pressure timesteps from file into inletPressureArray
	ifstream infile1(filename1.c_str());
	int t=0;
	string line1;
	stringstream Str1;

	if(infile1.is_open())
	{
		while(!infile1.eof())
		{
			{
				getline(infile1,line1);
				if (line1.empty()) //make sure empty lines are not read into array.
				{
//					cout << "Empty line." << endl;
				}
				else
				{
					Str1 << line1;
					Str1 >> inletPressureArray[t];
					Str1.clear(); // Stringstream needs to be cleared in order to be written correctly in next step.
//					cout << "inletPressureArray" << s << ": " << inletPressureArray[t] << endl;
					t++;
				}
			}
		}
		infile1.close();
	}	

	double tmpInletPressureArray[numberOfTimesteps];
	for(int z=0;z < numberOfTimesteps; z++)
	{
		tmpInletPressureArray[z]=inletPressureArray[z];
//		cout << "InletPressure timesteps " << z << ": " << inletPressureArray[z] << endl;
//		cout << "MyocardialPressure timesteps " << z << ": " << myocardialPressureArray[z] << endl;
	}


	double rho=1060;
	cout << " density rho: " << rho << " kg/m^3. " << endl;


	// choose tolerance for termination criterion
	double tolerance = 1e-12;
	cout << "termination criterion for outletFlow is " << tolerance << " m^3/s, corresponding. " << endl;

	
	int maxNumberOfCycles=10;
	cout << "maximum number of cycles to compute before automatic termination: " << maxNumberOfCycles << "." << endl;
	double capacitorVoltage[N_outlets][numberOfTimesteps];
	double initialCapacitorVoltage = 0;




	cout << "Enter initial capacitor voltage in m^2/s^2: (usually ~0.5)" << endl;
	cin >> initialCapacitorVoltage;
	for(int i=1; i<=N_outlets; i++)
	{
		capacitorVoltage[i][numberOfTimesteps-1]=initialCapacitorVoltage;
		cout << "initial capacitor Voltage @ outlet" << i << ": " << capacitorVoltage[i][numberOfTimesteps-1] << endl;
	}
	double meanRightAtrialPressure = 0;
	cout << "Enter mean right atrial pressure in m^2/s^2: (3.75 mmHg ~ 500 kg/(m*s^2) ~ 0.47 m^2/s^2" << endl;
	cin >> meanRightAtrialPressure;
	cout << "meanRightAtrialPressure: " << meanRightAtrialPressure << " m^2/s^2." << endl;		


	double modelCurrent[N_outlets][numberOfTimesteps][2], venousCurrent[N_outlets][numberOfTimesteps], capacitorCurrent[N_outlets][numberOfTimesteps]; //required for computation of new capacitorVoltage. all currents are positive in direction of the mutual node of the three branches. Like this all three currents always add to zero!


	for(int i=1; i<=N_outlets; i++)
	{
	modelCurrent[i][numberOfTimesteps-1][0] = rho*(inletPressureArray[numberOfTimesteps-1] - (myocardialPressureArray[numberOfTimesteps-1] + capacitorVoltage[i][numberOfTimesteps-1]))/vesselResistancesArray[i];
	venousCurrent[i][numberOfTimesteps-1] = rho*(meanRightAtrialPressure - (myocardialPressureArray[numberOfTimesteps-1] + capacitorVoltage[i][numberOfTimesteps-1]))/venousResistancesArray[i];
	capacitorCurrent[i][numberOfTimesteps-1] = - modelCurrent[i][numberOfTimesteps-1][0] - venousCurrent[i][numberOfTimesteps-1];

	cout << "initial modelCurrent (volume flow) @ outlet" << i << ": " << modelCurrent[i][numberOfTimesteps-1][0] << " m^3/s." << endl;	
	cout << "initial venousCurrent (volume flow) @ outlet" << i << ": " << venousCurrent[i][numberOfTimesteps-1] << " m^3/s." << endl;	
	cout << "initial capacitorCurrent (volume flow) @ outlet" << i << ": " << capacitorCurrent[i][numberOfTimesteps-1] << " m^3/s." << endl;	
	}		

	// choose name of output file with list table of times and capacitorVoltage
//	string outputfilename;
//	cout << "What is the desired outputfilename?" << endl;
//	cin >> outputfilename;
//	ofstream finalOutput(outputfilename.c_str());


	for(int z=0;z < numberOfTimesteps; z++)
	{
		cout << "inletPressure timesteps " << z << ": " << inletPressureArray[z] << endl;
		cout << "tmpInletPressure timesteps " << z << ": " << tmpInletPressureArray[z] << endl;
		cout << "MyocardialPressure timesteps " << z << ": " << myocardialPressureArray[z] << endl;
	}

	ofstream output;
	ofstream output2;
	output.open ("control.txt");
	double testMeanTotalFlux = 0;	
	for(int L=1; L<=N_outlets; L++)
	{
	bool isBreak = false;
	for(int cycleCounter=0; cycleCounter < maxNumberOfCycles; cycleCounter++)
	{



		double meanOutletFlow = 0;
		for(int timeCounter=0;timeCounter < numberOfTimesteps; timeCounter++)
		{
		
		if(cycleCounter > 1 && timeCounter == numberOfTimesteps-1)
		{
				 		output << " outlet" << L << "timeCounter is " << timeCounter << ", the end of for-loop is reached. checking for periodicity." <<  endl; //remainder << endl;
			double deviation[numberOfTimesteps];
			double maxDeviation=0;
			int timestepOfMaxDeviation=0;
			for(int r=0; r<numberOfTimesteps; r++)
			{
//				double difference = 0;
				deviation[r] = fabs(modelCurrent[L][r][cycleCounter%2] - modelCurrent[L][r][(cycleCounter-1)%2]);
				output << " modelCurrent cycle " << cycleCounter << " timeCounter " << r << ": " << modelCurrent[L][r][cycleCounter%2] << endl;
				output << " modelCurrent cycle " << cycleCounter-1 << " timeCounter " << r << ": " << modelCurrent[L][r][(cycleCounter-1)%2] << endl;

//				if(deviation[r] < 0)
//				{
//					output << "deviation was smaller 0" << endl;
//					deviation[r] = -1*difference;
					if(deviation[r] > maxDeviation)
					{
						maxDeviation = deviation[r];
						timestepOfMaxDeviation = r;
						output << " maxDeviation " << maxDeviation << " newly set at timestep " << r << endl;
					}
				output << " difference at cycle " << cycleCounter-1 << " timeCounter " << r << ": " << deviation[r] << endl;
				output << " maxDeviation at cycle " << cycleCounter-1 << " timeCounter " << timestepOfMaxDeviation << ": " << maxDeviation << endl;
//				}
//				else
//				{
//					output << "deviation was larger 0" << endl;
//					deviation[r] = difference;
//					if(deviation[r] > maxDeviation)
//					{
//						maxDeviation = deviation[r];
//						timestepOfMaxDeviation = r;
//						output << " maxDeviation " << maxDeviation << " newly set at timestep " << r << endl;
//					}
//				}

			}
			if(maxDeviation < tolerance)
			{
				output << "maxDeviation is smaller than desired tolerance after " << cycleCounter-1 << " cycles. Write resulting modelCurrents in file and leave! " << endl;
				cout << "writing outletFlow" << L << endl;



		double finalMeanOutletFlow = 0;
		std::stringstream numberedFilenames;
		std::stringstream numberedFilenames2;
		numberedFilenames2 << "outletFlowTimesteps" << L << ".txt";
		numberedFilenames << "outletFlow" << L;
		ofstream output3(numberedFilenames.str().c_str());
		output3 << "(" << endl;
		ofstream output2(numberedFilenames2.str().c_str());
//		output2 << "// MU[kg/(m*s)_tauCharge_tauDischarge: " << Info << ", fractalResistance " << outletFractalsArray[s] <<", cycleDuration: " << cycleDuration << ", numberOfTimesteps: " << numberOfTimesteps << endl;
		for(int G=0; G<10; G++)
		{
		for(int k=0; k<numberOfTimesteps; k++)
		{
			if(G==0)
			{
			output2 << /*k*timeStepSize << " " <<*/ modelCurrent[L][k][cycleCounter%2] << endl;
			finalMeanOutletFlow += modelCurrent[L][k][cycleCounter%2];

			}
			output3 << "(" << (static_cast<double> (G)*numberOfTimesteps + k)*timeStepSize << " " << -modelCurrent[L][k][cycleCounter%2] << ")" << endl;
		}
		}

		finalMeanOutletFlow = finalMeanOutletFlow/numberOfTimesteps;
		testMeanTotalFlux += finalMeanOutletFlow;
		cout << "finalMeanOutletFlow at outlet" << L << " at cycle " << cycleCounter-1 << ": " << finalMeanOutletFlow << " m^3/s" << endl;
		output3 << ")" << endl;
		output2.close();
		output3.close();
		meanOutletFlow += modelCurrent[L][timeCounter][cycleCounter%2];
				isBreak = true;
				cout << "termination criterion fulfilled after cycle: " << cycleCounter << ". " << endl;
			}
			else
			{
				output << " maxDeviation = " << maxDeviation << " is larger than desired tolerance " << tolerance << " at timestep " << timestepOfMaxDeviation << " within cycle, go on! " << endl;
			}
		}

			output << "intraMyocardialPressureArray value at time " << timeCounter*timeStepSize << " is: " << myocardialPressureArray[timeCounter] << endl;
			if(timeCounter==0)
			{
//			cout << "(inletPressureArray[timeCounter] - (myocardialPressureArray[timeCounter] + capacitorVoltage[L][numberOfTimesteps-1])) : " << inletPressureArray[timeCounter]  << " - (" <<  myocardialPressureArray[timeCounter] << " + " <<  capacitorVoltage[L][numberOfTimesteps-1] << ") " << endl;
			modelCurrent[L][timeCounter][cycleCounter%2] = rho*(inletPressureArray[timeCounter] - (myocardialPressureArray[timeCounter] + capacitorVoltage[L][numberOfTimesteps-1]))/vesselResistancesArray[L];
			venousCurrent[L][timeCounter] = rho*(meanRightAtrialPressure - (myocardialPressureArray[timeCounter] + capacitorVoltage[L][numberOfTimesteps-1]))/venousResistancesArray[L];
			capacitorCurrent[L][timeCounter] = - modelCurrent[L][timeCounter][cycleCounter%2] - venousCurrent[L][timeCounter];
			meanOutletFlow += modelCurrent[L][timeCounter][cycleCounter%2];

			output << "modelCurrent @ outlet" << L << ": " << modelCurrent[L][timeCounter][cycleCounter%2]  << " m^3/s" << endl;
			output << "venousCurrent @ outlet" << L << ": " << venousCurrent[L][timeCounter] << " m^3/s" << endl;		
			output << "capacitorCurrent @ outlet" << L << ": " << capacitorCurrent[L][timeCounter] << " m^3/s" << endl;


			capacitorVoltage[L][timeCounter] = changingCapacitorVoltage(timeStepSize,  capacitorVoltage[L][numberOfTimesteps-1], 
rho*(inletPressureArray[timeCounter] - (myocardialPressureArray[timeCounter] + capacitorVoltage[L][timeCounter-1]))/vesselResistancesArray[L] 
+ rho*(meanRightAtrialPressure - (myocardialPressureArray[timeCounter] + capacitorVoltage[L][timeCounter-1]))/venousResistancesArray[L],  
capacitorCurrent[L][numberOfTimesteps-1],
capacitanceArray[L],
rho);
			}
			else
			{
//			cout << "(inletPressureArray[timeCounter] - (myocardialPressureArray[timeCounter] + capacitorVoltage[L][timeCounter-1])) : " << inletPressureArray[timeCounter]  << " - (" <<  myocardialPressureArray[timeCounter] << " + " <<  capacitorVoltage[L][timeCounter-1] << ") " << endl;
			modelCurrent[L][timeCounter][cycleCounter%2] = rho*(inletPressureArray[timeCounter] - (myocardialPressureArray[timeCounter] + capacitorVoltage[L][timeCounter-1]))/vesselResistancesArray[L];
			venousCurrent[L][timeCounter] = rho*(meanRightAtrialPressure - (myocardialPressureArray[timeCounter] + capacitorVoltage[L][timeCounter-1]))/venousResistancesArray[L];
			capacitorCurrent[L][timeCounter] = - modelCurrent[L][timeCounter][cycleCounter%2] - venousCurrent[L][timeCounter];
			meanOutletFlow += modelCurrent[L][timeCounter][cycleCounter%2];

			output << "modelCurrent @ outlet" << L << ": " << modelCurrent[L][timeCounter][cycleCounter%2]  << " m^3/s" << endl;
			output << "venousCurrent @ outlet" << L << ": " << venousCurrent[L][timeCounter] << " m^3/s" << endl;		
			output << "capacitorCurrent @ outlet" << L << ": " << capacitorCurrent[L][timeCounter] << " m^3/s" << endl;


			capacitorVoltage[L][timeCounter] = changingCapacitorVoltage(timeStepSize,  capacitorVoltage[L][timeCounter-1], 
rho*(inletPressureArray[timeCounter] - (myocardialPressureArray[timeCounter] + capacitorVoltage[L][timeCounter-1]))/vesselResistancesArray[L] 
+ rho*(meanRightAtrialPressure - (myocardialPressureArray[timeCounter] + capacitorVoltage[L][timeCounter-1]))/venousResistancesArray[L],  
capacitorCurrent[L][timeCounter-1],
capacitanceArray[L],
rho);
			}





	output.precision(10);
	output << "capacitorVoltage @ outlet" << L << "at time " << timeCounter*timeStepSize << " is: " << capacitorVoltage[L][timeCounter] << endl;



		meanOutletFlow = meanOutletFlow/numberOfTimesteps;
		output << "meanOutletFlow at outlet" << L << " at cycle " << cycleCounter << ": " << meanOutletFlow << " m^3/s" << endl;


		output << "modelCurrent outlet" << L << " timestep " << timeCounter << ": " << modelCurrent[L][timeCounter][cycleCounter%2] << endl;
		}




	if (isBreak == true)
	{
		break;
		cout << "isBreak == " << isBreak << ". Breaking for-loop!" << endl;
	}
	}	
	}	
	cout << "meanTotalFlux: " << testMeanTotalFlux << "m^3/s." << endl;	

	output.close();
	return 0;
}








