#include <iostream>
#define _USE_MATH_DEFINES
#include <math.h>
#include <stdio.h>
#include <fstream>
#include <sstream>
#include <stdint.h>
#include <string>
#include <vector>

using namespace std;

int getNumberOfLines(string file) // function to obtain number of Lines from File with myocardial Pressure. Name of file is inserted in command line when programm is executed.
{
	int number_of_lines=0;
	string line;
	ifstream myfile(file.c_str());

	if(myfile.is_open())
	{
		while(!myfile.eof())
		{
			{
				getline(myfile,line);
				if (line.empty()) // make sure, only non-blank lines are counted!
				{
//					cout << "Empty line." << endl;
				}
				else
				{
//					cout << line << endl;
					number_of_lines++;
				}
			}
		}
		myfile.close();
	}

//	cout << "Number of lines in " << file << " is " << number_of_lines << endl;
	
	return number_of_lines;
}

double readFile(string fileName, double array[], int s)
{
	ifstream infile(fileName.c_str());
//	int s=0;
	string line;
	stringstream Str;

	if(infile.is_open())
	{
		while(!infile.eof())
		{
			{
				getline(infile,line);
				if (line.empty()) //make sure empty lines are not read into array.
				{
//					cout << "Empty line." << endl;
				}
				else
				{
					Str << line;
					Str >> array[s];
					Str.clear(); // Stringstream needs to be cleared in order to be written correctly in next step.
//					cout << "outletRadius" << s << ":" << outletRadiusArray[s] << endl;
					s++;
				}
			}
		}
		infile.close();
	}

	return 0;
}

int main()
{
	int N_outlets=0;
	string fileOutletFractals;

	cout << "What is name of inputFile with outletFractals?" << endl;
	cin >> fileOutletFractals;
	N_outlets = getNumberOfLines(fileOutletFractals);
	cout << "Number of outlets is: " << N_outlets << endl;

	double outletFractalsArray[N_outlets];

	readFile(fileOutletFractals,outletFractalsArray,1);

	for(int i=1; i<=N_outlets; i++)
	{
		cout << "outletFractal outlet" << i << ": " << outletFractalsArray[i] << endl;
		
	}

	int numberOfTimesteps = 0;
	string inletPressureFile;
	cout << "Insert name of inletPressureFile" << endl;
	cin >> inletPressureFile;
	numberOfTimesteps = getNumberOfLines(inletPressureFile);
	cout << "number of timesteps is: " << numberOfTimesteps << endl;

	double cycleDuration = 1;
	cout << "Insert cardiac cycle duration (in s): " << endl;	
	cin >> cycleDuration;
	double timeStepSize=0;
	timeStepSize = cycleDuration/numberOfTimesteps;
	cout << "time step size is: " << timeStepSize << " s" << endl;	

	double ventricularPressureScalingArray[N_outlets];
	readFile("ventricularPressureScaling.txt",ventricularPressureScalingArray,1);	
	for(int i=1; i<=N_outlets; i++)
	{
		cout << "ventricularPressureScaling at outlet" << i << ": " << ventricularPressureScalingArray[i] << endl;
		
	}

	double inletPressureArray[numberOfTimesteps];
	double capillaryPressureArray65[numberOfTimesteps];
	double capillaryPressureArray75[numberOfTimesteps];
	double capillaryPressureArray85[numberOfTimesteps];
	double capillaryPressureArray95[numberOfTimesteps];
	double capillaryPressureArray105[numberOfTimesteps];
	double capillaryPressureArray115[numberOfTimesteps];	
	double capillaryPressureArray125[numberOfTimesteps];



	readFile(inletPressureFile,inletPressureArray,0);
	readFile("capillaryPressureTimesteps65.txt",capillaryPressureArray65,0);
	readFile("capillaryPressureTimesteps75.txt",capillaryPressureArray75,0);
	readFile("capillaryPressureTimesteps85.txt",capillaryPressureArray85,0);
	readFile("capillaryPressureTimesteps95.txt",capillaryPressureArray95,0);
	readFile("capillaryPressureTimesteps105.txt",capillaryPressureArray105,0);
	readFile("capillaryPressureTimesteps115.txt",capillaryPressureArray115,0);
	readFile("capillaryPressureTimesteps125.txt",capillaryPressureArray125,0);

	
	for(int j=0; j<numberOfTimesteps; j++)
	{
		cout << "inletPressure" << j << ": " << inletPressureArray[j] << endl;	
		cout << "capillaryPressure65" << j << ": " << capillaryPressureArray65[j] << endl;
		cout << "capillaryPressure75" << j << ": " << capillaryPressureArray75[j] << endl;
		cout << "capillaryPressure85" << j << ": " << capillaryPressureArray85[j] << endl;
		cout << "capillaryPressure95" << j << ": " << capillaryPressureArray95[j] << endl;
		cout << "capillaryPressure105" << j << ": " << capillaryPressureArray105[j] << endl;
		cout << "capillaryPressure115" << j << ": " << capillaryPressureArray115[j] << endl;
		cout << "capillaryPressure125" << j << ": " << capillaryPressureArray125[j] << endl;	
	}


	std::vector<std::vector<double> > outletPressureArray(N_outlets);
	for(size_t index=0; index<N_outlets; index++)
	{
		outletPressureArray[index].resize(numberOfTimesteps);
	}


	for(int z=0; z<N_outlets; z++)
	{
		if((ventricularPressureScalingArray[z+1]-0) <= 0.143 /*equals ~1/7*/)
		{		
		cout << "ventricularPressureScaling for outlet" << z+1 << ": is between " << 0 << " & " << 0.143 << ". Use capillaryPressureArray125" << endl;
			for(size_t y=0; y<numberOfTimesteps; y++)
			{	
				outletPressureArray[z][y] = capillaryPressureArray125[y] + (inletPressureArray[y] - capillaryPressureArray125[y]) * outletFractalsArray[z+1];
				
			}
		}
		else if((ventricularPressureScalingArray[z+1]-1*0.143) <= (0.143))
		{
			cout << "ventricularPressureScaling for outlet" << z+1 << ": is between " << 1*0.143 << " & " << 2*0.143 << ". Use capillaryPressureArray115" << endl;
			for(size_t y=0; y<numberOfTimesteps; y++)
			{	
				outletPressureArray[z][y] = capillaryPressureArray115[y] + (inletPressureArray[y] - capillaryPressureArray115[y]) * outletFractalsArray[z+1];
		
			}
		}
		else if((ventricularPressureScalingArray[z+1]-2*0.143) <=  (0.143))
		{
			cout << "ventricularPressureScaling for outlet" << z+1 << ": is between " << 2*0.143 << " & " << 3*0.143 << ". Use capillaryPressureArray105" << endl;
			for(size_t y=0; y<numberOfTimesteps; y++)
			{	
				outletPressureArray[z][y] = capillaryPressureArray105[y] + (inletPressureArray[y] - capillaryPressureArray105[y]) * outletFractalsArray[z+1];
	
			}
		}
		else if((ventricularPressureScalingArray[z+1]-3*0.143) <= (0.143))
		{
			cout << "ventricularPressureScaling for outlet" << z+1 << ": is between " << 3*0.143 << " & " << 4*0.143 << ". Use capillaryPressureArray95" << endl;
			for(size_t y=0; y<numberOfTimesteps; y++)
			{	
				outletPressureArray[z][y] = capillaryPressureArray95[y] + (inletPressureArray[y] - capillaryPressureArray95[y]) * outletFractalsArray[z+1];
	
			}
		}
		else if((ventricularPressureScalingArray[z+1]-4*0.143) <= (0.143))
		{
			cout << "ventricularPressureScaling for outlet" << z+1 << ": is between " << 4*0.143 << " & " << 5*0.143 << ". Use capillaryPressureArray85" << endl;
			for(size_t y=0; y<numberOfTimesteps; y++)
			{	
				outletPressureArray[z][y] = capillaryPressureArray85[y] + (inletPressureArray[y] - capillaryPressureArray85[y]) * outletFractalsArray[z+1];
	
			}
		}
		else if((ventricularPressureScalingArray[z+1]-5*0.143) <= (0.143))
		{
			cout << "ventricularPressureScaling for outlet" << z+1 << ": is between " << 5*0.143 << " & " << 6*0.143 << ". Use capillaryPressureArray75" << endl;
			for(size_t y=0; y<numberOfTimesteps; y++)
			{	
				outletPressureArray[z][y] = capillaryPressureArray75[y] + (inletPressureArray[y] - capillaryPressureArray75[y]) * outletFractalsArray[z+1];
	
			}
		}
		else if((ventricularPressureScalingArray[z+1]-6*0.143) <= (0.143))
		{	
			cout << "ventricularPressureScaling for outlet" << z+1 << ": is between " << 6*0.143 << " & " << 7*0.143 << "~=" << 1 << ". Use capillaryPressureArray65" << endl;
			for(size_t y=0; y<numberOfTimesteps; y++)
			{
				outletPressureArray[z][y] = capillaryPressureArray65[y] + (inletPressureArray[y] - capillaryPressureArray65[y]) * outletFractalsArray[z+1];
	
			}
		}
	}
	for(int i=1; i<=N_outlets; i++)
	{
		cout << "ventricularPressureScaling at outlet" << i << ": " << ventricularPressureScalingArray[i] << endl;
		
	}
/*
	for(int r=1; r<=N_outlets; r++)
	{
//		cout << "outlet" << r << " pressure timesteps:" << endl;
		for(int j=0; j<numberOfTimesteps; j++)
		{
			outletPressureArray[r][j] = capillaryPressureArray[j] + (inletPressureArray[j] - capillaryPressureArray[j]) * outletFractalsArray[r];
//			cout << "outletPressure" << r << " at timestep " << j << ": " << outletPressureArray[r][j] << endl;
		}
	}
*/
	string Info;
	cout << "Insert Info about file in following format: MU[kg/(m*s)_tauCharge_tauDischarge" << endl;
	cin >> Info;

	for(int s=1; s<=N_outlets; s++)
	{
		std::stringstream numberedFilenames;
		std::stringstream numberedFilenames2;
		numberedFilenames2 << "outletPressureTimesteps" << s << ".txt";
		numberedFilenames << "outletPressure" << s << ".txt";
		ofstream output(numberedFilenames.str().c_str());
		output << "(" << endl;
		ofstream output2(numberedFilenames2.str().c_str());
//		output2 << "// MU[kg/(m*s)_tauCharge_tauDischarge: " << Info << ", fractalResistance " << outletFractalsArray[s] <<", cycleDuration: " << cycleDuration << ", numberOfTimesteps: " << numberOfTimesteps << endl;
		for(int k=0; k<numberOfTimesteps; k++)
		{
			output2 << /*k*timeStepSize << " " <<*/ outletPressureArray[s-1][k] << endl;
//			cout << (static_cast<double> (N)*numberOfTimesteps + k)*timeStepSize << ", " << outletPressureArray[s][k] << endl;
		}
		for(int N=0;N<10;N++)
		{
			for(int k=0; k<numberOfTimesteps; k++)
			{
				output << "(" << (static_cast<double> (N)*numberOfTimesteps + k)*timeStepSize << " " << outletPressureArray[s-1][k] << ")" << endl;
//				cout << (static_cast<double> (N)*numberOfTimesteps + k)*timeStepSize << ", " << outletPressureArray[s][k] << endl;
			}
		}
		output << ")" << endl;
		output.close();
	}

	return 0;
}








